package com.wissamfawaz;

import java.util.Comparator;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class Main {

	public static void main(String[] args) {
		String str1 = "This is a";
		String str2 = "sample string";
		
		Stream<String> stream1 = Stream.of(str1.split("\\s+"));
		Stream<String> stream2 = Stream.of(str2.split("\\s+"));
		Stream<String> stream = Stream.concat(stream1, stream2);
		System.out.println(stream.distinct().count() + " distinct words");
		
		String str = str1 + " " + str2;
		String[] words = str.split("\\s+");
		Stream.of(words).forEach(word -> System.out.printf("%s ", word));
		System.out.println();
		
		System.out.printf("Words sorted by length: %s%n", 
				Stream.of(words)
					  .sorted(Comparator.comparing(String::length))
					  .collect(Collectors.toList()));
		
		
		System.out.printf("First word starting with s: %s%n", 
				Stream.of(words).filter(s->s.startsWith("s")).findFirst().orElse(""));
		
		System.out.printf("Any word starting with i: %s%n", 
				Stream.of(words).anyMatch(s -> s.startsWith("i")));
		
		
		
		
		
		
		
		
		

	}

}
