package com.wissamfawaz;

import java.math.BigInteger;
import java.util.Random;
import java.util.function.Supplier;
import java.util.stream.Stream;

public class Main {

	public static void main(String[] args) {
		/*
		 * Random rnd = new Random(); Supplier<Integer> supplier = () -> rnd.nextInt();
		 * for(int i=1; i<=10; i++) System.out.println(supplier.get());
		 */
		Stream<String> echos = Stream.generate(() -> "echo");
		echos.limit(10)
		     .forEach(str -> System.out.printf("%s ", str));
		System.out.println();
		
		Stream<Double> rndValues = Stream.generate(Math::random);
		System.out.printf("First value less 0.2: %f%n", 
				rndValues.filter(val -> val < 0.2).findFirst().get());
		
		Stream<BigInteger> bigInts = Stream.iterate(BigInteger.ZERO, 
				n -> n.add(BigInteger.ONE));
		
		System.out.printf("Sum of values between 1 and 1000: %d%n", 
				bigInts.limit(1001)
					   .mapToInt(BigInteger::intValue)
					   .sum());
				
				
				
				
				
				
				
				
				
				
				
				
				
		
		
		
		
		
		
		
		
		
		

	}

}
