package com.wissamfawaz;

import java.util.ArrayList;
import java.util.List;
import java.util.function.IntPredicate;
import java.util.function.Predicate;

public class Main {

	public static void main(String[] args) {
		List<Employee> employees = new ArrayList<>();
		
		employees.add(new Employee("Wissam Fawaz", 23));
		employees.add(new Employee("Samer Saab", 32));
		employees.add(new Employee("Chadi Abou-Rjeily", 26));
		employees.add(new Employee("Zahi Nakad", 29));
		employees.add(new Employee("Abdallah Sfeir", 59));
		
		Predicate<Employee> youngerThan30 = e -> e.getAge() < 30;
		Predicate<Employee> olderThan30 = e -> e.getAge() > 30;
		
		printEmployeesByAge(employees, "Employees younger than 30: ", youngerThan30);
		printEmployeesByAge(employees, "Employees older than 30: ", olderThan30);
		
		IntPredicate greaterThan15 = val -> val > 15;
		System.out.println(greaterThan15.test(16));
		IntPredicate lessThan100 = val -> val < 100;
		System.out.println(lessThan100.test(90));
		System.out.println(greaterThan15.and(lessThan100).test(78));
		
	}
	
	private static void printEmployeesByAge(List<Employee> employees, 
			String ageMessage, Predicate<Employee> ageCondition) {
		System.out.println(ageMessage);
		System.out.println("======================");
		for(Employee employee : employees)
			if(ageCondition.test(employee))
				System.out.println(employee.getName());
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
	}

}
